% Ex_4_5.m              28oct2015
% Testing the auditory system
clear all

Fs = 8000;    
% sampling frequency, Hz
dur = 1.5;       % sound duration, seconds
L = Fs .* dur;  % no. of samples
z = zeros(1,L);  zz = zeros(1,2*L);
return

%%   sequence of tones
s = sin(2*pi*300*dur*[0:L-1]./L);   sh = s .* hamming(length(s))';
s1 = sin(2*pi*301*dur*[0:L-1]./L);   s1h = s1 .* hamming(length(s))';
s2 = sin(2*pi*302*dur*[0:L-1]./L);   s2h = s2 .* hamming(length(s))';
s3 = sin(2*pi*303*dur*[0:L-1]./L);   s3h = s3 .* hamming(length(s))';
 sound([z s s1 zz s s2 zz s s3],Fs);  % consecutive tones
% sound([z s z s1 zz s z s2 zz s z s3],Fs);  % pause between tones
% sound([z sh s1h zz sh s2h zz sh s3h],Fs);  % windowed tones

%%
s = sin(2*pi*3000*dur*[0:L-1]./L);
s1 = sin(2*pi*3001*dur*[0:L-1]./L);
s2 = sin(2*pi*3002*dur*[0:L-1]./L);
s3 = sin(2*pi*3003*dur*[0:L-1]./L);
 sound([z s s1 zz s s2 zz s s3],Fs);  % consecutive tones

%%   simultaneous tones
s = .5* sin(2*pi*1000*dur*[0:L-1]./L);
s1 = .5* sin(2*pi*990*dur*[0:L-1]./L);
s2 = .5* sin(2*pi*980*dur*[0:L-1]./L);
s3 = .5* sin(2*pi*950*dur*[0:L-1]./L);
s4 = .5* sin(2*pi*920*dur*[0:L-1]./L);
s5 = .5* sin(2*pi*860*dur*[0:L-1]./L);
sound([z (s+s1) zz (s+s2) zz (s+s3) zz (s+s4) zz (s+s5)],Fs);

%%    critical band: masking (concept only)
clear all
Fs = 8000;     % sampling frequency, Hz
dur = .7;       % sound duration, seconds
L = Fs .* dur;  % no. of samples
f_axis = linspace(0,Fs/2,L/2);

freq = 1000;
s = sin(2*pi*freq*dur*[0:L-1]./L);

for delta = (-.2:.02:.2)*pi;
  alpha = .85;    beta = cos(2*pi*freq/Fs + delta);  
  b = [1  0  -1] * (1-alpha) /2;
  a = [1  -beta*(1+alpha)  alpha];    % IIR bandpass, see 4(5)30
% freqz(b,a); pause(1);
  d = filter(b,a, randn(size(s))*10);
  x = s + d;
  X = abs(fft(x));
  soundsc(x,Fs); pause(dur);
  plot(f_axis,X(1:L/2));  axis([0 Fs/2 0 2000]); 
  drawnow;
	end;

return
